package com.dzy.ffmod2;

import com.mojang.brigadier.CommandDispatcher;
import net.minecraft.commands.CommandSourceStack;
import net.minecraft.commands.Commands;
import net.minecraft.core.BlockPos;
import net.minecraft.server.level.ServerLevel;
import net.minecraft.world.entity.EntityType;
import net.minecraft.world.entity.MobSpawnType;
import net.minecraft.world.entity.monster.Zombie;
import net.minecraft.world.entity.monster.Skeleton;
import net.minecraft.world.entity.monster.Creeper;
import net.minecraft.world.entity.monster.Spider;
import net.minecraftforge.common.MinecraftForge;
import net.minecraftforge.event.RegisterCommandsEvent;
import net.minecraftforge.eventbus.api.SubscribeEvent;
import net.minecraftforge.fml.common.Mod;

import java.util.Random;

@Mod(Ffmod2.MODID)
public class Ffmod2 {
    public static final String MODID = "ffmod2";

    public Ffmod2() {
        MinecraftForge.EVENT_BUS.register(this);
    }

    @SubscribeEvent
    public void onRegisterCommands(RegisterCommandsEvent event) {
        CommandDispatcher<CommandSourceStack> dispatcher = event.getDispatcher();
        dispatcher.register(
                Commands.literal("start")
                        .executes(context -> {
                            ServerLevel world = context.getSource().getLevel();
                            BlockPos pos = context.getSource().getPlayer().blockPosition();

                            // 生成20个怪物
                            Random random = new Random();
                            for (int i = 0; i < 20; i++) {
                                // 随机选择怪物类型
                                int monsterType = random.nextInt(4);
                                BlockPos spawnPos = pos.offset(
                                        random.nextInt(40) - 20,  // -20到20之间
                                        0,
                                        random.nextInt(40) - 20
                                );

                                // 确保生成在表面上
                                spawnPos = world.getHeightmapPos(net.minecraft.world.level.levelgen.Heightmap.Types.MOTION_BLOCKING_NO_LEAVES, spawnPos);

                                switch (monsterType) {
                                    case 0:
                                        Zombie zombie = EntityType.ZOMBIE.create(world);
                                        if (zombie != null) {
                                            zombie.moveTo(spawnPos, 0, 0);
                                            zombie.finalizeSpawn(world, world.getCurrentDifficultyAt(spawnPos), MobSpawnType.COMMAND, null, null);
                                            world.addFreshEntity(zombie);
                                        }
                                        break;
                                    case 1:
                                        Skeleton skeleton = EntityType.SKELETON.create(world);
                                        if (skeleton != null) {
                                            skeleton.moveTo(spawnPos, 0, 0);
                                            skeleton.finalizeSpawn(world, world.getCurrentDifficultyAt(spawnPos), MobSpawnType.COMMAND, null, null);
                                            world.addFreshEntity(skeleton);
                                        }
                                        break;
                                    case 2:
                                        Creeper creeper = EntityType.CREEPER.create(world);
                                        if (creeper != null) {
                                            creeper.moveTo(spawnPos, 0, 0);
                                            creeper.finalizeSpawn(world, world.getCurrentDifficultyAt(spawnPos), MobSpawnType.COMMAND, null, null);
                                            world.addFreshEntity(creeper);
                                        }
                                        break;
                                    case 3:
                                        Spider spider = EntityType.SPIDER.create(world);
                                        if (spider != null) {
                                            spider.moveTo(spawnPos, 0, 0);
                                            spider.finalizeSpawn(world, world.getCurrentDifficultyAt(spawnPos), MobSpawnType.COMMAND, null, null);
                                            world.addFreshEntity(spider);
                                        }
                                        break;
                                }
                            }

                            context.getSource().sendSuccess(() -> net.minecraft.network.chat.Component.literal("村庄保卫战开始！怪物正在靠近！"), true);
                            return 1;
                        })
        );
    }
}